(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                      Fait bouger le drapeau hollandais                     
*)

{-$DEFINE Fps}       { Affiche le nombre d'images par secondes }
{$DEFINE TEcran}    { Utilise un double-buffer pour l'affichage du dernier point }
{-$DEFINE EffacePas} { Efface les anciens points du drapeau en couleur+fonc }

{$M 4096,0,64000}

uses Clavier,EcranVga {$IFDEF Fps} ,Fps {$ENDIF};

const
  Vitesse = 2; Taille = 3; curve = 125;
  SinMin = 30; Amplitude = 8;
  xmax = 230 div Taille;
  ymax = 140 div Taille;

var
  TamponEcran: PtrImage;
  TableSin: array[0..255] of word;
  TablePos: array[0..xmax,0..ymax] of word;

  i: byte;

  x,y, xp,yp : word; UnTierYmax : word;

procedure PreCalcul; begin
  for I := 0 to 255 do TableSin[i] := round(sin(i*4*pi/255)*Amplitude)+SinMin;
end;

procedure DemoDrapeau; begin
  i := 0;
  UnTierYmax := ymax div 3;

  repeat
    for y := 0 to UnTierYmax do
      for x := 0 to xmax do begin
        PutPixelOfs (TablePos[x,y],{$IFDEF EffacePas} 4 {$ELSE} 0 {$ENDIF});

        xp := Taille*X + TableSin[ (i +curve*x +curve*y   ) mod 255];
        yp := Taille*Y + TableSin[ (i +4*x     +curve*y +y) mod 255];

        TablePos[x,y] := xp + yp shl 8 + yp shl 6;

        PutPixelOfs (TablePos[x,y], 12);
      end;

    for y := UnTierYmax to 2*UnTierYmax do
      for x := 0 to xmax do begin
        PutPixelOfs (TablePos[x,y], {$IFDEF EffacePas} 7 {$ELSE} 0 {$ENDIF});

        xp := Taille*x + TableSin[ (i +curve*x +curve*y   ) mod 255];
        yp := Taille*y + TableSin[ (i +4*x     +curve*y +y) mod 255];

        TablePos[x,y] := xp + yp shl 8 + yp shl 6;

        PutPixelOfs (TablePos[x,y], 15);
      end;

    for y := 2*UnTierYmax to ymax do
      for x := 0 to xmax do begin
        PutPixelOfs (TablePos[x,y], {$IFDEF EffacePas} 1 {$ELSE} 0 {$ENDIF});

        xp := Taille*x + TableSin[ (i +curve*x +curve*y   ) mod 255];
        yp := Taille*y + TableSin[ (i +4*x     +curve*y +y) mod 255];

        TablePos[x,y] := xp + yp shl 8 + yp shl 6;

        PutPixelOfs (TablePos[x,y], 9);
      end;

    {$IFDEF Fps} ActuFps; {$ELSE} AttendEcran; {$ENDIF}
    {$IFDEF TEcran} AfficheEcran; {$ENDIF}

    i := (i+Vitesse) mod 255;
  until TouchPresse;
end;

begin
  {$IFDEF TEcran}
  if MemAvail<64000 then begin
    ModeTxt;
    Writeln ('Pas assez de mmoire libre pour cre un double buffer !');
    Writeln ('(Manque ',64000-MemAvail,' octets)');
    Halt (8);
  end;
  GetMem (TamponEcran,64000);
  ChangeDestEcran (TamponEcran);
  EffaceEcran (0);
  {$ENDIF}

  PreCalcul;

  ModeVga256;

  {$IFDEF Fps} InitFps (0,0,FALSE); {$ENDIF}

  DemoDrapeau;

  ModeTxt;
  {$IFDEF TEcran} Dispose (TamponEcran); {$ENDIF}
  {$IFDEF Fps} FinFps; {$ENDIF}
end.
